package ij.plugin.frame.jedit;

import java.awt.Font;
import java.awt.font.FontRenderContext;
import java.awt.font.LineMetrics;
import java.awt.GraphicsEnvironment;
import javax.swing.text.Segment;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2008</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class JLineMetrics {
    private static Font font;
    private static int fontStyl;
    private static int fontSize;
    private static FontRenderContext frc;
    private static LineMetrics lm;
    private static String text;
    private static Segment currentLine;

    public static LineMetrics getLineMetrics(Font font, JEditTextArea textArea){
        String fontsName[] = null;
        Font[] fonts = null;
        char[] c = null;
        //boolean trueFont = false;
        currentLine = new Segment();
        int currentLineIndex = textArea.getCaretLine();
        textArea.getLineText(currentLineIndex,currentLine);
        if(currentLine != null){
            c = currentLine.array;
        }else{c=new char[1];c[0]='w';}
        text = new String(c);
        frc = new FontRenderContext(null, false, false);
        GraphicsEnvironment ge = GraphicsEnvironment.
                                 getLocalGraphicsEnvironment();
        fontsName = ge.getAvailableFontFamilyNames();
        fonts     = ge.getAllFonts();
        if (fontsName == null){
            return lm;
        }
        for (int i=0; i<fontsName.length; i++){
            if(font.getFamily().equals(fontsName[i])){
                //trueFont = true;
                fontStyl=fonts[i].getStyle();
                fontSize=fonts[i].getSize();
                lm = fonts[i].getLineMetrics(text, frc);
            }
        }
        return lm;
    }
    public static double getAscent(){
        double ascent = lm.getAscent();
        return ascent;
    }
    public static double getDescent(){
        double descent = lm.getDescent();
        return descent;
    }
    public static double getLeading(){
        double leading = lm.getLeading();
        return leading;
    }
    public static double getHight(){
        double height = lm.getHeight();
        return height;
    }
    public static double getWight(){
        double width = font.getMaxCharBounds(frc).getWidth();
        return width;
    }
}
